#!/usr/bin/env python2.5

import depsd

from os import system
from os.path import dirname, abspath, join
from glob import glob
import sys

mysuperdir = dirname(dirname(abspath(__file__)))

#for path in glob(join(dirname(mysuperdir), 'deps.d', '*')):
    #sys.path.insert(0, path)

#sys.path.insert(0, dirname(mysuperdir))

from os.path import join
from urllib import urlopen, urlencode
from urlparse import urlsplit
from lxml.etree import parse, tostring

from fulltextextractor import  FullTextExtractor, SruUpdateClient
from merescocore.framework import be

xPathToFulltextUrl = '//mods:mods/mods:location/mods:url/text()'
fulltextUrlExists = 'fulltext.url.exists'

fulltextRecordsQuery = '(%s exact true) NOT (fulltext.item.status = done OR fulltext.item.status = failed)' % fulltextUrlExists

namespaces = {
    'mods': 'http://www.loc.gov/mods/v3',
    'srw':"http://www.loc.gov/zing/srw/",
    'meta':"http://meresco.com/namespace/harvester/meta"}

class UrlFetcher(object):

    def urlopen(self, url):
        yield urlopen(url).read()

def main(sruHost, sruPort, sruPath, updateHost, updatePort, updatePath):
    dna = be(
        (FullTextExtractor(),
            (UrlFetcher(), ),
            (SruUpdateClient(updateHost, updatePort, updatePath), ),
        ),
    )

    xmlNode = parse(urlopen("http://%s:%s%s?%s" % (sruHost, sruPort, sruPath, urlencode({
        'operation':'searchRetrieve',
        'version':'1.1',
        'query': fulltextRecordsQuery,
        'recordPacking': 'xml',
        'recordSchema':'meta',
        'x-recordSchema':'metadata'}))))

    for record in xmlNode.xpath('//srw:record', namespaces=namespaces):
        uploadId = ''.join( record.xpath('srw:recordData/meta:meta/meta:upload/meta:id/text()', namespaces=namespaces))
        fulltextUrls = record.xpath('srw:extraRecordData/*'+xPathToFulltextUrl, namespaces=namespaces)
        print uploadId, fulltextUrls
        dna.addFullText(uploadId, fulltextUrls)
        print "DONE"

if __name__ == '__main__':
    from sys import argv, stdout
    args = argv[1:]
    if len(args) != 6:
        print "Usage: pendingfulltext.py example.org 7080 /sru example.org 7071 /update"
        exit(1)

    sruHost, sruPort, sruPath, updateHost, updatePort, updatePath = args

    main(sruHost, sruPort, sruPath, updateHost, updatePort, updatePath)
